package com.gree.mall.manager.schedule;

import com.aliyuncs.utils.StringUtils;
import com.gree.mall.manager.logic.common.CommonLogic;
import com.gree.mall.manager.logic.tag.AsyncWxTagLogic;
import com.gree.mall.manager.logic.tag.DepartmentSyncLogic;
import com.gree.mall.manager.plus.entity.AdminCompanyWechat;
import lombok.SneakyThrows;
import me.chanjar.weixin.common.error.WxErrorException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.annotation.Scheduled;
import org.springframework.stereotype.Component;

import java.util.List;


@Component
public class DepartmentSyncSchedule {

    @Autowired
    private AsyncWxTagLogic asyncWxTagLogic;
    @Autowired
    private DepartmentSyncLogic departmentSyncLogic;
    @Autowired
    CommonLogic commonLogic;

    /**
     * 同步企业成员信息
     * @throws WxErrorException
     */
//    @Scheduled(fixedDelay = 3 * 60 * 1000)
//    public void usertask() throws WxErrorException {
//        List<AdminCompanyWechat> adminCompanyList = commonLogic.getAdminCompanyList();
//        if(adminCompanyList.size() == 0){
//            return;
//        }
//        for(AdminCompanyWechat adminCompanyWechat : adminCompanyList) {
//            if(StringUtils.isNotEmpty(adminCompanyWechat.getMchId()) && StringUtils.isNotEmpty(adminCompanyWechat.getSubAppId())
//                    &&StringUtils.isNotEmpty(adminCompanyWechat.getSubSecret())) {
//                departmentSyncLogic.syncDepartmentData(adminCompanyWechat);
//            }
//        }
//    }

    /**
     * 同步外部联系人和标签数据
     * @throws WxErrorException
     */
//    @Scheduled(fixedDelay = 30 * 60 * 1000)
//    public void tagTask() throws WxErrorException {
//        List<AdminCompanyWechat> adminCompanyList = commonLogic.getAdminCompanyList();
//        if(adminCompanyList.size() == 0){
//            return;
//        }
//        for(AdminCompanyWechat adminCompanyWechat : adminCompanyList) {
//            if(StringUtils.isNotEmpty(adminCompanyWechat.getMchId()) && StringUtils.isNotEmpty(adminCompanyWechat.getSubAppId())
//                    &&StringUtils.isNotEmpty(adminCompanyWechat.getSubSecret())) {
//                asyncWxTagLogic.syncWxUserData(adminCompanyWechat.getCorpId(),adminCompanyWechat);
//            }
//        }
//    }

    /**
     * 同步部门数据
     * @throws WxErrorException
     */
//    @Scheduled(fixedDelay = 1 * 60 * 1000)
//    public void departTask() throws WxErrorException {
//        List<AdminCompanyWechat> adminCompanyList = commonLogic.getAdminCompanyList();
//        if(adminCompanyList.size() == 0){
//            return;
//        }
//        for(AdminCompanyWechat adminCompanyWechat : adminCompanyList) {
//            if(StringUtils.isNotEmpty(adminCompanyWechat.getMchId()) && StringUtils.isNotEmpty(adminCompanyWechat.getSubAppId())
//                    &&StringUtils.isNotEmpty(adminCompanyWechat.getSubSecret())) {
//                departmentSyncLogic.pullDepartmentList(adminCompanyWechat);
//            }
//        }
//    }


}
